(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     44303,       1035]
NotebookOptionsPosition[     42998,        992]
NotebookOutlinePosition[     43431,       1009]
CellTagsIndexPosition[     43388,       1006]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Read", " ", "a", " ", "CHN", " ", "file", " ", "describing", " ", "a", 
    " ", "channel", " ", 
    RowBox[{"problem", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"inputfile1", " ", "=", " ", 
    RowBox[{"SystemDialogInput", "[", " ", 
     RowBox[{"\"\<FileOpen\>\"", " ", ",", 
      RowBox[{"FileNameJoin", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\</Users/mfsiqueira/Dropbox/workdir/software/ongoing/bc2d/data/\
channels\>\"", ",", "\"\<.chn\>\""}], "}"}], "]"}]}], " ", "]"}]}], " ", 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.667776081978917*^9, 3.667776176131474*^9}, 
   3.667777348979733*^9, {3.667777397494316*^9, 3.667777429056473*^9}, {
   3.6677775256635036`*^9, 3.667777535889044*^9}, {3.6677777590790367`*^9, 
   3.667777769226953*^9}, {3.667778125486433*^9, 3.6677782068654823`*^9}, {
   3.667779065025579*^9, 3.667779065848155*^9}, 3.667780965052286*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"npieces", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile1", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "1"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncsegpp", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile1", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "2"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"closefg", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile1", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "3"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"npoints", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile1", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "4"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"degree1", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile1", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "5"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}]}], "Input",
 CellChangeTimes->{{3.667778395228985*^9, 3.6677784181833076`*^9}, {
  3.667778570005628*^9, 3.667778578787161*^9}, {3.667778774224394*^9, 
  3.6677787752868223`*^9}, {3.6677788738623247`*^9, 3.6677788741565332`*^9}, {
  3.6677789254372463`*^9, 3.667778929131238*^9}, {3.667779020595037*^9, 
  3.667779147998418*^9}, {3.6677791928600283`*^9, 3.6677792217486067`*^9}, {
  3.667779281932827*^9, 3.667779289597076*^9}, {3.6677800031710043`*^9, 
  3.6677800125705442`*^9}, {3.667780172254795*^9, 3.667780201254416*^9}, {
  3.667780327436247*^9, 3.667780417280366*^9}, {3.66778096835749*^9, 
  3.6677809714432497`*^9}, {3.667781175783554*^9, 3.667781267996286*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", " ", 
   RowBox[{
   "lx", " ", ",", " ", "ly", " ", ",", " ", "i", " ", ",", " ", 
    "LowerEnvelope"}], " ", "]"}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LowerEnvelope", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"lx", " ", "=", " ", 
      RowBox[{"ToExpression", "[", " ", 
       RowBox[{"Import", "[", " ", 
        RowBox[{"inputfile1", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"\"\<Words\>\"", " ", ",", " ", 
           RowBox[{
            RowBox[{"2", "i"}], " ", "-", " ", "1", " ", "+", " ", "5"}]}], 
          " ", "}"}]}], " ", "]"}], " ", "]"}]}], " ", ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ly", " ", "=", " ", 
      RowBox[{"ToExpression", "[", " ", 
       RowBox[{"Import", "[", " ", 
        RowBox[{"inputfile1", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"\"\<Words\>\"", " ", ",", " ", 
           RowBox[{
            RowBox[{"2", "i"}], "         ", "+", " ", "5"}]}], " ", "}"}]}], 
        " ", "]"}], " ", "]"}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"LowerEnvelope", " ", "=", " ", 
      RowBox[{"Append", "[", " ", 
       RowBox[{"LowerEnvelope", " ", ",", " ", 
        RowBox[{"{", " ", 
         RowBox[{"lx", "  ", ",", "ly"}], " ", "}"}]}], " ", "]"}]}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", " ", 
     RowBox[{"i", " ", ",", " ", "1", " ", ",", " ", "npoints"}], " ", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LowerEnvelope", " ", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"If", " ", "[", " ", 
    RowBox[{
     RowBox[{"closefg", " ", "\[Equal]", " ", "1"}], " ", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lx", " ", "=", " ", 
        RowBox[{"ToExpression", "[", " ", 
         RowBox[{"Import", "[", " ", 
          RowBox[{"inputfile1", " ", ",", " ", 
           RowBox[{"{", " ", 
            RowBox[{"\"\<Words\>\"", " ", ",", " ", "6"}], " ", "}"}]}], " ", 
          "]"}], " ", "]"}]}], " ", ";", "\[IndentingNewLine]", 
       RowBox[{"ly", " ", "=", " ", 
        RowBox[{"ToExpression", "[", " ", 
         RowBox[{"Import", "[", " ", 
          RowBox[{"inputfile1", " ", ",", " ", 
           RowBox[{"{", " ", 
            RowBox[{"\"\<Words\>\"", " ", ",", " ", "7"}], " ", "}"}]}], " ", 
          "]"}], " ", "]"}]}], " ", ";", "\[IndentingNewLine]", " ", 
       RowBox[{"Append", "[", " ", 
        RowBox[{"LowerEnvelope", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"lx", "  ", ",", "ly"}], " ", "}"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", ")"}], " ", ",", "\[IndentingNewLine]", 
     "LowerEnvelope"}], " ", "\[IndentingNewLine]", "]"}]}], " ", 
  ";"}]}], "Input",
 CellChangeTimes->{{3.667780558723564*^9, 3.667780697386023*^9}, {
  3.667780973651697*^9, 3.6677809746030188`*^9}, {3.667781255869171*^9, 
  3.667781265476363*^9}, {3.667781348739958*^9, 3.667781350482173*^9}, {
  3.6677822963727217`*^9, 3.66778238960236*^9}, {3.667782488679628*^9, 
  3.667782490463533*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", " ", 
   RowBox[{
   "ux", " ", ",", " ", "uy", " ", ",", " ", "i", " ", ",", " ", 
    "UpperEnvelope"}], " ", "]"}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UpperEnvelope", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ux", " ", "=", " ", 
      RowBox[{"ToExpression", "[", " ", 
       RowBox[{"Import", "[", " ", 
        RowBox[{"inputfile1", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"\"\<Words\>\"", " ", ",", " ", 
           RowBox[{
            RowBox[{"2", "i"}], " ", "-", " ", "1", " ", "+", " ", "5", " ", 
            "+", " ", 
            RowBox[{"2", " ", "npoints"}]}]}], " ", "}"}]}], " ", "]"}], " ", 
       "]"}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"uy", " ", "=", " ", 
      RowBox[{"ToExpression", "[", " ", 
       RowBox[{"Import", "[", " ", 
        RowBox[{"inputfile1", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"\"\<Words\>\"", " ", ",", " ", 
           RowBox[{
            RowBox[{"2", "i"}], "         ", "+", " ", "5", " ", "+", " ", 
            RowBox[{"2", " ", "npoints"}]}]}], "}"}]}], " ", "]"}], " ", 
       "]"}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"UpperEnvelope", " ", "=", " ", 
      RowBox[{"Append", "[", " ", 
       RowBox[{"UpperEnvelope", " ", ",", " ", 
        RowBox[{"{", " ", 
         RowBox[{"ux", "  ", ",", "uy"}], " ", "}"}]}], " ", "]"}]}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", " ", 
     RowBox[{"i", " ", ",", " ", "1", " ", ",", " ", "npoints"}], " ", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UpperEnvelope", " ", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"If", " ", "[", " ", 
    RowBox[{
     RowBox[{"closefg", " ", "\[Equal]", " ", "1"}], " ", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ux", " ", "=", " ", 
        RowBox[{"ToExpression", "[", " ", 
         RowBox[{"Import", "[", " ", 
          RowBox[{"inputfile1", " ", ",", " ", 
           RowBox[{"{", " ", 
            RowBox[{"\"\<Words\>\"", " ", ",", " ", 
             RowBox[{"6", " ", "+", " ", 
              RowBox[{"2", " ", "npoints"}]}]}], " ", "}"}]}], " ", "]"}], 
         " ", "]"}]}], " ", ";", "\[IndentingNewLine]", 
       RowBox[{"uy", " ", "=", " ", 
        RowBox[{"ToExpression", "[", " ", 
         RowBox[{"Import", "[", " ", 
          RowBox[{"inputfile1", " ", ",", " ", 
           RowBox[{"{", " ", 
            RowBox[{"\"\<Words\>\"", " ", ",", " ", 
             RowBox[{"7", " ", "+", " ", 
              RowBox[{"2", " ", "npoints"}]}]}], " ", "}"}]}], " ", "]"}], 
         " ", "]"}]}], " ", ";", "\[IndentingNewLine]", " ", 
       RowBox[{"Append", "[", " ", 
        RowBox[{"UpperEnvelope", " ", ",", " ", 
         RowBox[{"{", " ", 
          RowBox[{"ux", "  ", ",", "uy"}], " ", "}"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", ")"}], " ", ",", "\[IndentingNewLine]", 
     "UpperEnvelope"}], " ", "\[IndentingNewLine]", "]"}]}], " ", 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6677806651417828`*^9, 3.667780790209673*^9}, {
  3.6677809758837967`*^9, 3.667780976763191*^9}, {3.667781283556879*^9, 
  3.667781295931169*^9}, {3.6677824093779497`*^9, 3.667782429040452*^9}, {
  3.6677824607699947`*^9, 3.667782483432066*^9}, {3.6677842471852713`*^9, 
  3.667784248295849*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Read", " ", "a", " ", "SPL", " ", "file", " ", "describing", " ", "a", 
    " ", "spline", " ", 
    RowBox[{"curve", "."}]}], "    ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"inputfile2", " ", "=", " ", 
    RowBox[{"SystemDialogInput", "[", " ", 
     RowBox[{"\"\<FileOpen\>\"", " ", ",", 
      RowBox[{"FileNameJoin", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\</Users/mfsiqueira/Dropbox/workdir/software/ongoing/bc2d/data/\
spcurves\>\"", ",", "\"\<.spl\>\""}], "}"}], "]"}]}], " ", "]"}]}], " ", 
   ";"}]}]], "Input",
 CellChangeTimes->{
  3.667780835639435*^9, {3.6677809421656446`*^9, 3.667781021475795*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ncurves", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile2", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "1"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"degree2", " ", "=", 
   RowBox[{"ToExpression", "[", " ", 
    RowBox[{"Import", "[", " ", 
     RowBox[{"inputfile2", " ", ",", " ", 
      RowBox[{"{", " ", 
       RowBox[{"\"\<Words\>\"", " ", ",", " ", "2"}], " ", "}"}]}], " ", 
     "]"}], " ", "]"}]}], " ", ";"}]}], "Input",
 CellChangeTimes->{{3.667781027942707*^9, 3.667781061850389*^9}, {
  3.667781242918674*^9, 3.667781244780465*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"On", "[", " ", "Assert", " ", "]"}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", " ", 
  RowBox[{"degree1", " ", "==", " ", "degree2"}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", " ", 
  RowBox[{"npieces", " ", "\[Equal]", " ", "ncurves"}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", "Assert", "]"}], " ", ";"}]}], "Input",
 CellChangeTimes->{
  3.667781062869075*^9, {3.667781382594613*^9, 3.667781469871004*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", " ", 
   RowBox[{
   "controlpolys", " ", ",", " ", "cp", " ", ",", " ", "offset", " ", ",", 
    " ", "i", " ", ",", " ", "j", " ", ",", " ", "xc", " ", ",", " ", "yc", 
    "  ", ",", " ", "cp"}], " ", "]"}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"controlpolys", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"offset", " ", "=", " ", 
      RowBox[{
       RowBox[{"2", " ", "i", 
        RowBox[{"(", " ", 
         RowBox[{"degree2", " ", "+", " ", "1"}], " ", ")"}]}], " ", "+", " ",
        "2"}]}], " ", ";", " ", "\[IndentingNewLine]", 
     RowBox[{"cp", " ", "=", " ", 
      RowBox[{"{", " ", "}"}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"xc", " ", "=", " ", 
         RowBox[{"ToExpression", "[", " ", 
          RowBox[{"Import", "[", " ", 
           RowBox[{"inputfile2", " ", ",", " ", 
            RowBox[{"{", " ", 
             RowBox[{"\"\<Words\>\"", " ", ",", " ", 
              RowBox[{
               RowBox[{"2", " ", "j"}], " ", "-", " ", "1", " ", "+", " ", 
               "offset"}]}], " ", "}"}]}], " ", "]"}], " ", "]"}]}], " ", ";",
         "\[IndentingNewLine]", 
        RowBox[{"yc", " ", "=", " ", 
         RowBox[{"ToExpression", "[", " ", 
          RowBox[{"Import", "[", " ", 
           RowBox[{"inputfile2", " ", ",", " ", 
            RowBox[{"{", " ", 
             RowBox[{"\"\<Words\>\"", " ", ",", " ", 
              RowBox[{
               RowBox[{"2", "j"}], "         ", "+", " ", "offset"}]}], " ", 
             "}"}]}], " ", "]"}], " ", "]"}]}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"cp", " ", "=", " ", 
         RowBox[{"Append", "[", " ", 
          RowBox[{"cp", " ", ",", " ", 
           RowBox[{"{", " ", 
            RowBox[{"xc", "  ", ",", "yc"}], " ", "}"}]}], " ", "]"}]}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", " ", 
        RowBox[{"j", " ", ",", " ", "1", "  ", ",", " ", 
         RowBox[{"degree2", " ", "+", " ", "1"}]}], " ", "}"}]}], 
      "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"controlpolys", " ", "=", " ", 
      RowBox[{"Append", "[", " ", 
       RowBox[{"controlpolys", " ", ",", " ", "cp"}], " ", "]"}]}]}], " ", 
    ",", "\[IndentingNewLine]", 
    RowBox[{"{", "  ", 
     RowBox[{"i", "  ", ",", " ", "0", "  ", ",", " ", 
      RowBox[{"ncurves", " ", "-", " ", "1"}]}], " ", "}"}]}], 
   "\[IndentingNewLine]", "]"}], " ", ";"}]}], "Input",
 CellChangeTimes->{{3.667781456880734*^9, 3.667781820249269*^9}, {
  3.66778188550419*^9, 3.667781885726532*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Generates", " ", "the", " ", "graphics", " ", "objects", " ", "of", " ", 
    "the", " ", "sequence"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"of", " ", "breakpoints", " ", "of", " ", "a", " ", 
    RowBox[{"channel", "."}]}], "                   ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ListOfChannelPoints", "[", "cpoly_", "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", " ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"m", " ", ",", "i", " ", ",", "res"}], " ", "}"}], " ", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", " ", "=", " ", 
         RowBox[{"Length", "[", " ", "cpoly", " ", "]"}]}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RGBColor", "[", " ", 
            RowBox[{"1", " ", ",", "0", " ", ",", "0"}], " ", "]"}], " ", ",", 
           RowBox[{"PointSize", "[", "0.02", "]"}]}], " ", "}"}]}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"Append", "[", " ", 
            RowBox[{"res", " ", ",", 
             RowBox[{"Point", "[", " ", 
              RowBox[{"cpoly", "[", 
               RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", "]"}]}], " ", 
            "]"}]}], " ", ",", "\[IndentingNewLine]", 
          RowBox[{"{", " ", 
           RowBox[{"i", " ", ",", "1", " ", ",", "m"}], " ", "}"}]}], 
         "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", "res"}
        ], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
   " ", ";"}]}]], "Input",
 CellChangeTimes->{{3.667776076886319*^9, 3.667776085290535*^9}, {
  3.667777886984056*^9, 3.6677778886477613`*^9}, {3.6677779520660067`*^9, 
  3.6677779525399437`*^9}, {3.667778156650579*^9, 3.6677781759171057`*^9}, {
  3.6677787787592916`*^9, 3.667778808918502*^9}, {3.667778880677412*^9, 
  3.667778887652728*^9}, {3.66777893938791*^9, 3.667778939451515*^9}, {
  3.6677808271522827`*^9, 3.667780828254798*^9}, {3.667783333661778*^9, 
  3.667783360434224*^9}, {3.667783689483856*^9, 3.667783727659569*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Generates", " ", "the", " ", "graphics", " ", "objects", " ", "of", " ", 
    "the", " ", "sequence"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"of", " ", "breakpoints", " ", "of", " ", "a", " ", "control", " ", 
    RowBox[{"polygon", "."}]}], "           ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ListOfControlPolygonPoints", "[", " ", "cpoly_", " ", "]"}], " ",
     ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", " ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"m", " ", ",", "i", " ", ",", "res"}], " ", "}"}], " ", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", " ", "=", " ", 
         RowBox[{"Length", "[", " ", "cpoly", " ", "]"}]}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", 
         RowBox[{"{", " ", 
          RowBox[{
           RowBox[{"RGBColor", "[", " ", 
            RowBox[{"0", " ", ",", "0", " ", ",", "1"}], " ", "]"}], " ", ",", 
           RowBox[{"PointSize", "[", " ", "0.01", " ", "]"}]}], " ", "}"}]}], 
        " ", ";", "\[IndentingNewLine]", 
        RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"Append", "[", " ", 
            RowBox[{"res", " ", ",", 
             RowBox[{"Point", "[", " ", 
              RowBox[{"cpoly", "[", 
               RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", "]"}]}], " ", 
            "]"}]}], " ", ",", "\[IndentingNewLine]", 
          RowBox[{"{", " ", 
           RowBox[{"i", " ", ",", "1", " ", ",", "m"}], " ", "}"}]}], 
         "\[IndentingNewLine]", "]"}], "  ", ";", "\[IndentingNewLine]", 
        "res"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
     "]"}]}], " ", ";"}]}]], "Input",
 CellChangeTimes->{{3.667783390396508*^9, 3.667783434241097*^9}, {
  3.667783486018224*^9, 3.667783487256174*^9}, {3.667783623557169*^9, 
  3.667783681092039*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Generates", " ", "the", " ", "graphics", " ", "objects", " ", "of", " ", 
    "the", " ", "sequence"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"of", " ", "edges", " ", "of", " ", "a", " ", 
    RowBox[{"channel", "."}]}], "                         ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ListOfChannelEdges", "[", " ", "cpoly_", " ", "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", " ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"m", " ", ",", " ", "i", " ", ",", "res"}], " ", "}"}], " ", 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", " ", "=", " ", 
         RowBox[{
          RowBox[{"Length", "[", "cpoly", "]"}], " ", "-", " ", "1"}]}], " ", 
        ";", "\[IndentingNewLine]", 
        RowBox[{"On", "[", " ", "Assert", " ", "]"}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Assert", "[", " ", 
         RowBox[{"m", " ", "\[GreaterEqual]", " ", "1"}], " ", "]"}], " ", 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Off", "[", " ", "Assert", " ", "]"}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", " ", 
          RowBox[{"RGBColor", "[", " ", 
           RowBox[{"1", " ", ",", "1", " ", ",", "0"}], " ", "]"}], " ", 
          "}"}]}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"Append", "[", " ", 
            RowBox[{"res", " ", ",", " ", 
             RowBox[{"Line", "[", 
              RowBox[{"{", " ", 
               RowBox[{
                RowBox[{"cpoly", "[", 
                 RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", ",", 
                RowBox[{"cpoly", "[", 
                 RowBox[{"[", " ", 
                  RowBox[{"i", " ", "+", " ", "1"}], " ", "]"}], " ", "]"}]}],
                " ", "}"}], " ", "]"}]}], " ", "]"}]}], " ", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", " ", 
           RowBox[{"i", " ", ",", "1", " ", ",", " ", "m"}], " ", "}"}]}], 
         "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", 
        "res"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
     "]"}]}], " ", ";"}]}]], "Input",
 CellChangeTimes->{{3.666565758506418*^9, 3.66656575859202*^9}, {
  3.667783372948621*^9, 3.667783381717148*^9}, {3.6677835572793503`*^9, 
  3.6677836216372423`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Generates", " ", "the", " ", "graphics", " ", "objects", " ", "of", " ", 
    "the", " ", "sequence"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"of", " ", "edges", " ", "of", " ", "a", " ", "control", " ", 
    RowBox[{"polygon", "."}]}], "                 ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "                                                ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ListOfControlPolygonEdges", "[", "cpoly_", "]"}], " ", ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", " ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", " ", 
        RowBox[{"m", " ", ",", "i", " ", ",", "res"}], " ", "}"}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"m", " ", "=", " ", 
          RowBox[{
           RowBox[{"Length", "[", "cpoly", "]"}], " ", "-", " ", "1"}]}], " ",
          ";", "\[IndentingNewLine]", 
         RowBox[{"On", "[", "Assert", "]"}], " ", ";", "\[IndentingNewLine]", 
         
         RowBox[{"Assert", "[", " ", 
          RowBox[{"m", " ", "\[GreaterEqual]", " ", "1"}], " ", "]"}], " ", 
         ";", "\[IndentingNewLine]", 
         RowBox[{"Off", "[", "Assert", "]"}], " ", ";", "\[IndentingNewLine]", 
         RowBox[{"res", " ", "=", " ", 
          RowBox[{"{", 
           RowBox[{"RGBColor", "[", " ", 
            RowBox[{"0", " ", ",", "0", " ", ",", "1"}], " ", "]"}], " ", 
           "}"}]}], " ", ";", "\[IndentingNewLine]", 
         RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"res", " ", "=", " ", 
            RowBox[{"Append", "[", " ", 
             RowBox[{"res", " ", ",", " ", 
              RowBox[{"Line", "[", " ", 
               RowBox[{"{", " ", 
                RowBox[{
                 RowBox[{"cpoly", "[", 
                  RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", ",", 
                 RowBox[{"cpoly", "[", 
                  RowBox[{"[", " ", 
                   RowBox[{"i", " ", "+", " ", "1"}], " ", "]"}], "]"}]}], 
                " ", "}"}], " ", "]"}]}], " ", "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", " ", 
            RowBox[{"i", " ", ",", "1", " ", ",", " ", "m"}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", 
         "res"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
      "]"}]}], " ", ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.667783452364737*^9, 3.6677835485504427`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Performs", " ", "general", " ", "affine", " ", "interpolation", " ", 
    "between", " ", "two", " ", "points", " ", "p", " ", "and"}], "  ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "q", " ", "with", " ", "respect", " ", "to", " ", "an", " ", "affine", " ", 
    RowBox[{"frame", " ", "[", 
     RowBox[{"r", ",", "s"}], "]"}], " ", "and", " ", "interpolating", " ", 
    "value"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"t", "."}], 
   "                                                              ", "*)"}], 
  " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"lerp", "[", "  ", 
     RowBox[{
     "p_", " ", ",", "q_", " ", ",", "r_", " ", ",", "s_", " ", ",", " ", 
      "t_"}], "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", " ", 
        RowBox[{"s", " ", "-", " ", "t"}], " ", ")"}], "/", 
       RowBox[{"(", " ", 
        RowBox[{"s", " ", "-", " ", "r"}], " ", ")"}]}], "  ", "p"}], " ", 
     "+", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", " ", 
        RowBox[{"t", " ", "-", " ", "r"}], " ", ")"}], "/", 
       RowBox[{"(", " ", 
        RowBox[{"s", " ", "-", " ", "r"}], " ", ")"}]}], "q"}]}]}], " ", 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.666569967896027*^9, 3.666569985667143*^9}, {
  3.667783748227015*^9, 3.667783770009021*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Computes", " ", "a", " ", "point", " ", "F", 
    RowBox[{"(", "t", ")"}], " ", "on", " ", "a", " ", "curve", " ", "using", 
    " ", "the", " ", "de", " ", "Casteljau"}], "        ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"algorithm", "."}], 
   "                                                     ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"deCas", "[", " ", 
     RowBox[{"cpoly_", " ", ",", "r_", " ", ",", "s_", " ", ",", "t_"}], " ", 
     "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"bb", " ", ",", 
        RowBox[{"b", " ", "=", " ", 
         RowBox[{"{", "}"}]}], " ", ",", " ", "m", " ", ",", " ", "i", " ", 
        ",", " ", "j"}], " ", "}"}], " ", ",", "\[IndentingNewLine]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bb", " ", "=", " ", "cpoly"}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"m", " ", "=", " ", 
         RowBox[{
          RowBox[{"Length", "[", " ", "bb", " ", "]"}], " ", "-", " ", 
          "1"}]}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"b", " ", "=", " ", 
              RowBox[{"Append", "[", " ", 
               RowBox[{"b", " ", ",", " ", 
                RowBox[{"lerp", "[", " ", 
                 RowBox[{
                  RowBox[{"bb", "[", 
                   RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", ",", 
                  RowBox[{"bb", "[", 
                   RowBox[{"[", " ", 
                    RowBox[{"i", " ", "+", " ", "1"}], " ", "]"}], "]"}], " ",
                   ",", "r", " ", ",", "s", " ", ",", "t"}], " ", "]"}]}], 
               " ", "]"}]}], " ", ",", "\[IndentingNewLine]", 
             RowBox[{"{", " ", 
              RowBox[{"i", " ", ",", "1", " ", ",", 
               RowBox[{"m", " ", "-", " ", "j", " ", "+", " ", "1"}]}], " ", 
              "}"}]}], "\[IndentingNewLine]", "]"}], " ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"bb", "=", " ", "b"}], " ", ";", "\[IndentingNewLine]", 
           RowBox[{"b", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], " ", ",", "\[IndentingNewLine]", 
          RowBox[{"{", " ", 
           RowBox[{"j", " ", ",", "1", " ", ",", "m"}], " ", "}"}]}], 
         "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"bb", "[", 
         RowBox[{"[", " ", "1", " ", "]"}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}], "\[IndentingNewLine]", "]"}]}], " ", ";"}]}]], "Input",
 CellChangeTimes->{{3.666570021766644*^9, 3.666570049032818*^9}, {
  3.667783782145596*^9, 3.667783846615876*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Computes", " ", "a", " ", "\"\<n\>\"", " ", "points", " ", "on", " ", "a",
     " ", "Bezier", " ", "curve", " ", "using", " ", "the", " ", "de"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Casteljau", " ", 
    RowBox[{"algorithm", "."}]}], "                                  ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ComputePointsOnCurve", "[", " ", 
     RowBox[{"cpoly_", " ", ",", "r_", " ", ",", "s_", " ", ",", "n_"}], " ", 
     "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{
       "inc", " ", ",", "t", " ", ",", "pt", " ", ",", "lpts", " ", ",", "i", 
        " ", ",", "m", " ", ",", "res"}], " ", "}"}], " ", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"inc", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", " ", 
           RowBox[{"s", " ", "-", " ", "r"}], " ", ")"}], " ", "/", " ", 
          RowBox[{"(", " ", 
           RowBox[{"n", " ", "-", " ", "1"}], " ", ")"}]}]}], " ", ";", 
        "\[IndentingNewLine]", 
        RowBox[{"t", " ", "=", " ", "r"}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"lpts", " ", "=", " ", 
         RowBox[{"{", "}"}]}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"While", " ", "[", " ", 
         RowBox[{
          RowBox[{"t", " ", "\[LessEqual]", " ", "s"}], " ", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"pt", " ", "=", " ", 
            RowBox[{"deCas", "[", " ", 
             RowBox[{"cpoly", " ", ",", "r", " ", ",", "s", " ", ",", "t"}], 
             " ", "]"}]}], " ", ";", "\[IndentingNewLine]", 
           RowBox[{"lpts", " ", "=", " ", 
            RowBox[{"Append", "[", " ", 
             RowBox[{"lpts", " ", ",", " ", "pt"}], " ", "]"}]}], " ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"t", " ", "=", " ", 
            RowBox[{"t", " ", "+", " ", "inc"}]}]}]}], "\[IndentingNewLine]", 
         "]"}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", " ", 
          RowBox[{"RGBColor", "[", " ", 
           RowBox[{"0", " ", ",", "1", " ", ",", "0"}], " ", "]"}], " ", 
          "}"}]}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"m", " ", "=", " ", 
         RowBox[{
          RowBox[{"Length", "[", " ", "lpts", " ", "]"}], " ", "-", " ", 
          "1"}]}], " ", ";", "\[IndentingNewLine]", 
        RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"Append", "[", " ", 
            RowBox[{"res", " ", ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", " ", 
               RowBox[{
                RowBox[{"lpts", "[", 
                 RowBox[{"[", " ", "i", " ", "]"}], "]"}], " ", ",", 
                RowBox[{"lpts", "[", 
                 RowBox[{"[", " ", 
                  RowBox[{"i", "+", "1"}], " ", "]"}], "]"}]}], " ", "}"}], 
              " ", "]"}]}], " ", "]"}]}], " ", ",", "\[IndentingNewLine]", 
          RowBox[{"{", " ", 
           RowBox[{"i", " ", ",", "1", " ", ",", " ", "m"}], " ", "}"}]}], 
         "\[IndentingNewLine]", "]"}], " ", ";", "\[IndentingNewLine]", 
        "res"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
     "]"}]}], " ", ";"}]}]], "Input",
 CellChangeTimes->{{3.666570106226334*^9, 3.6665701370232353`*^9}, {
  3.667783860224861*^9, 3.667783941478751*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Create", " ", "the", " ", "list", " ", "of", " ", "breakpoints", " ", 
    "of", " ", "the", " ", "channel"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LowerPolyBreakPoints", " ", "=", " ", 
     RowBox[{"ListOfChannelPoints", "[", "  ", "LowerEnvelope", "  ", "]"}]}],
     " ", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"UpperPolyBreakPoints", " ", "=", " ", 
     RowBox[{"ListOfChannelPoints", "[", "  ", "UpperEnvelope", "  ", "]"}]}],
     " ", ";"}]}]}]], "Input",
 CellChangeTimes->{
  3.667781965254859*^9, {3.667782000556115*^9, 3.667782072913196*^9}, {
   3.6677839489741297`*^9, 3.667783955052106*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Create", " ", "the", " ", "list", " ", "of", " ", "edges", " ", "of", " ",
     "the", " ", "channel"}], "       ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "                                               ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LowerPolyEdges", " ", "=", " ", 
     RowBox[{"ListOfChannelEdges", "[", " ", "LowerEnvelope", " ", "]"}]}], 
    " ", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"UpperPolyEdges", " ", "=", " ", 
     RowBox[{"ListOfChannelEdges", "[", " ", "UpperEnvelope", " ", "]"}]}], 
    " ", ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6677821098349123`*^9, 3.667782144319214*^9}, {
  3.667783960494224*^9, 3.667783966572464*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", " ", 
   RowBox[{
   "myspline", " ", ",", " ", "cpoly", " ", ",", " ", "curve", " ", ",", " ", 
    "cpolypoints", " ", ",", " ", "cpolyedges"}], " ", "]"}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cpolypoints", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cpolyedges", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myspline", " ", "=", " ", 
   RowBox[{"{", " ", "}"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", " ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"cpoly", " ", "=", " ", 
       RowBox[{"controlpolys", "[", 
        RowBox[{"[", " ", "i", " ", "]"}], "]"}]}], " ", ";", 
      "\[IndentingNewLine]", 
      RowBox[{"cpolypoints", " ", "=", " ", 
       RowBox[{"Append", "[", " ", 
        RowBox[{"cpolypoints", " ", ",", " ", 
         RowBox[{
         "ListOfControlPolygonPoints", "[", "  ", "cpoly", "  ", "]"}]}], " ",
         "]"}]}], " ", ";", "\[IndentingNewLine]", 
      RowBox[{"cpolyedges", "   ", "=", " ", 
       RowBox[{"Append", "[", " ", 
        RowBox[{"cpolyedges", " ", ",", " ", 
         RowBox[{
         "ListOfControlPolygonEdges", "[", "  ", "cpoly", "  ", "]"}]}], " ", 
        "]"}]}], " ", ";", "\[IndentingNewLine]", 
      RowBox[{"curve", " ", "=", " ", 
       RowBox[{"ComputePointsOnCurve", "[", " ", 
        RowBox[{
        "cpoly", " ", ",", " ", "0", " ", ",", " ", "1", " ", ",", " ", 
         "20"}], " ", "]"}]}], " ", ";", "\[IndentingNewLine]", 
      RowBox[{"myspline", " ", "=", " ", 
       RowBox[{"Append", "[", " ", 
        RowBox[{"myspline", " ", ",", " ", "curve"}], " ", "]"}]}]}], " ", 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", " ", 
      RowBox[{"i", " ", ",", " ", "1", " ", ",", " ", "ncurves"}], " ", 
      "}"}]}], "\[IndentingNewLine]", "]"}], " ", ";"}], " "}]}], "Input",
 CellChangeTimes->{
  3.667782596636757*^9, {3.667782681883535*^9, 3.66778272996143*^9}, {
   3.6677828041756268`*^9, 3.6677828819995527`*^9}, {3.667782915893188*^9, 
   3.667782925724559*^9}, 3.667782957731759*^9, {3.667783131160084*^9, 
   3.6677832478137903`*^9}, {3.667783972855919*^9, 3.667783982863091*^9}, {
   3.667784358300541*^9, 3.6677843594915333`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Show", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Thickness", "[", "0.005", "]"}], ",", "\[IndentingNewLine]", 
       "myspline", " ", ",", "\[IndentingNewLine]", 
       RowBox[{"Thickness", "[", "0.003", "]"}], ",", "\[IndentingNewLine]", 
       "LowerPolyEdges", " ", ",", "\[IndentingNewLine]", "UpperPolyEdges", 
       " ", ",", "\[IndentingNewLine]", "cpolyedges", " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Thickness", "[", "0.005", "]"}], ",", "\[IndentingNewLine]", 
       "LowerPolyBreakPoints", " ", ",", "\[IndentingNewLine]", 
       "UpperPolyBreakPoints", " ", ",", "\[IndentingNewLine]", 
       "cpolypoints"}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
     "]"}], " ", ",", "\[IndentingNewLine]", 
    RowBox[{"Axes", " ", "\[Rule]", " ", "False"}]}], "\[IndentingNewLine]", 
   "]"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.667783032764123*^9, 3.6677830696655684`*^9}, {
  3.667783286686233*^9, 3.6677833025973463`*^9}, {3.667784124322991*^9, 
  3.6677841243386297`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Thickness[0.005], 
    {RGBColor[0, 1, 0], 
     LineBox[{{1.25, 0.}, {1.2171053077708116`, 0.05697442119842541}}], 
     LineBox[{{1.2171053077708116`, 0.05697442119842541}, {
      1.1842106006706519`, 0.11394884327161392`}}], 
     LineBox[{{1.1842106006706519`, 0.11394884327161392`}, {
      1.1513158804490446`, 0.1709232670943286}}], 
     LineBox[{{1.1513158804490446`, 0.1709232670943286}, {1.1184211488555182`,
       0.22789769354133255`}}], 
     LineBox[{{1.1184211488555182`, 0.22789769354133255`}, {
      1.0855264076395974`, 0.2848721234873888}}], 
     LineBox[{{1.0855264076395974`, 0.2848721234873888}, {1.052631658550809, 
      0.3418465578072605}}], 
     LineBox[{{1.052631658550809, 0.3418465578072605}, {1.019736903338679, 
      0.39882099737571064`}}], 
     LineBox[{{1.019736903338679, 0.39882099737571064`}, {0.9868421437527336, 
      0.45579544306750247`}}], 
     LineBox[{{0.9868421437527336, 0.45579544306750247`}, {0.9539473815424986,
       0.512769895757399}}], 
     LineBox[{{0.9539473815424986, 0.512769895757399}, {0.921052618457501, 
      0.5697443563201632}}], 
     LineBox[{{0.921052618457501, 0.5697443563201632}, {0.8881578562472663, 
      0.6267188256305583}}], 
     LineBox[{{0.8881578562472663, 0.6267188256305583}, {0.8552630966613208, 
      0.6836933045633472}}], 
     LineBox[{{0.8552630966613208, 0.6836933045633472}, {0.8223683414491907, 
      0.7406677939932935}}], 
     LineBox[{{0.8223683414491907, 0.7406677939932935}, {0.7894735923604023, 
      0.7976422947951595}}], 
     LineBox[{{0.7894735923604023, 0.7976422947951595}, {0.7565788511444818, 
      0.8546168078437089}}], 
     LineBox[{{0.7565788511444818, 0.8546168078437089}, {0.7236841195509547, 
      0.9115913340137045}}], 
     LineBox[{{0.7236841195509547, 0.9115913340137045}, {0.6907893993293482, 
      0.9685658741799095}}], 
     LineBox[{{0.6907893993293482, 0.9685658741799095}, {0.6578946922291878, 
      1.0255404292170869`}}], 
     LineBox[{{0.6578946922291878, 1.0255404292170869`}, {0.625, 
      1.082515}}]}}, 
   {Thickness[0.003], 
    {RGBColor[1, 1, 0], LineBox[{{1., 0.}, {0.5, 0.8660254}}]}, 
    {RGBColor[1, 1, 0], LineBox[{{1.5, 0.}, {0.75, 1.29900381}}]}, 
    {RGBColor[0, 0, 1], LineBox[{{1.25, 0.}, {1.041667, 0.360838}}], 
     LineBox[{{1.041667, 0.360838}, {0.833333, 0.721676}}], 
     LineBox[{{0.833333, 0.721676}, {0.625, 1.082515}}]}}, 
   {Thickness[0.005], 
    {RGBColor[1, 0, 0], PointSize[0.02], PointBox[{1., 0.}], 
     PointBox[{0.5, 0.8660254}]}, 
    {RGBColor[1, 0, 0], PointSize[0.02], PointBox[{1.5, 0.}], 
     PointBox[{0.75, 1.29900381}]}, 
    {RGBColor[0, 0, 1], PointSize[0.01], PointBox[{1.25, 0.}], 
     PointBox[{1.041667, 0.360838}], PointBox[{0.833333, 0.721676}], 
     PointBox[{0.625, 1.082515}]}}},
  Axes->False,
  ImageSize->{488.4609375, Automatic}]], "Output",
 CellChangeTimes->{
  3.667783071192271*^9, {3.667783291109483*^9, 3.667783303390691*^9}, 
   3.667783990657381*^9, {3.667784065204941*^9, 3.667784082973425*^9}, {
   3.667784125422491*^9, 3.667784152617674*^9}, 3.667784212176854*^9, 
   3.667784265021308*^9, 3.667784313118269*^9, {3.6677843650769157`*^9, 
   3.667784376412648*^9}, 3.667784462964724*^9}]
}, Open  ]]
},
WindowSize->{1416, 786},
WindowMargins->{{5, Automatic}, {Automatic, 3}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 1180, 25, 80, "Input"],
Cell[1583, 40, 2247, 49, 97, "Input"],
Cell[3833, 91, 3277, 74, 301, "Input"],
Cell[7113, 167, 3568, 80, 301, "Input"],
Cell[10684, 249, 911, 22, 80, "Input"],
Cell[11598, 273, 750, 18, 46, "Input"],
Cell[12351, 293, 518, 13, 80, "Input"],
Cell[12872, 308, 2821, 64, 250, "Input"],
Cell[15696, 374, 2608, 55, 301, "Input"],
Cell[18307, 431, 2306, 51, 301, "Input"],
Cell[20616, 484, 2840, 63, 352, "Input"],
Cell[23459, 549, 2779, 61, 369, "Input"],
Cell[26241, 612, 1451, 39, 80, "Input"],
Cell[27695, 653, 2931, 63, 352, "Input"],
Cell[30629, 718, 3628, 80, 403, "Input"],
Cell[34260, 800, 948, 21, 114, "Input"],
Cell[35211, 823, 904, 20, 114, "Input"],
Cell[36118, 845, 2384, 54, 216, "Input"],
Cell[CellGroupData[{
Cell[38527, 903, 1199, 22, 318, "Input"],
Cell[39729, 927, 3253, 62, 677, "Output"]
}, Open  ]]
}
]
*)

